package org.maachang.luxio ;

/**
 * luxio定義.
 *  
 * @version 2008/12/05
 * @author  masahito suzuki
 * @since   Lux IO 0.1.0
 */
abstract class LuxioDefine {
    private LuxioDefine() {}
    
    /**
     * バージョン.
     */
    public static final String VERSION = "0.1.0" ;
    
    /**
     * プロパティ定義.
     */
    public static final String PROPERTY_NAME = "org.maachang.luxio.dir" ;
    
    /**
     * ライブラリ読み込み条件.
     */
    protected static final String LIB_MODE = "org.maachang.luxio.native" ;
    
    /**
     * ライブラリ名.
     */
    protected static final String LIB_NAME = "luxio" ;
    
    /**
     * Windowsライブラリ拡張子.
     */
    protected static final String WINDOWS_LIB_PLUS = ".dll" ;
    
    /**
     * Linuxライブラリ拡張子.
     */
    protected static final String LINUX_LIB_PLUS = ".so" ;
    
    /**
     * Nativeライブラリパス.
     */
    protected static final String NATIVE_PACKAGE = "org/maachang/luxio/native/" ;
    
    /**
     * デフォルトライブラリ格納ディレクトリ名.
     */
    protected static final String DEFAULT_DIR = ".lib_work" ;
    
}
